#include <iostream>
#include <cstdlib>
#include "barcode.h"

using std::atoi;
using std::cout;

int main(int argc, const char *const *argv)
{
	if(argc < 2)
	{
		cout << "Barcode generator v"VERSION" - copyright (C) 1992,2002 Bisqwit (http://bisqwit.iki.fi/)\n"
		        "Usage:\n"
		        "    barcode <stringtoencode> [encodingindex]\n"
		        "\n"
		        "Encoding indexes are defined in /usr/include/barcode.h,\n"
		        "and should be as follows:\n"
		        "\n"
		        "   0=any, 1=ean, 2=upc, 3=isbn, 4=code39,\n"
		        "   5=code128, 6=code128c, 7=code128b, 8=i25,\n"
		        "   9=raw code128, 10=codabar, 11=msi,\n"
		        "   12=plessey, 13=code93.\n"
		        " (At least when this program was written.)\n"
		        "\n"
		        "Output is text, and contains following lines:\n"
		        "  A <input>\n"
		        "  P <the barcode (widths of space and bars)>\n"
		        "  T <text info>\n"
		        "  E <encoding name>\n"
		        "  X <width>\n"
		        "  M <margin>\n";
		return 0;
	}
	Barcode_Item *bc = Barcode_Create(const_cast<char *> (argv[1]));
	
	Barcode_Encode(bc,
		argc>2 ? atoi(argv[2]) : BARCODE_ANY
	);
	
	cout << "A " << bc->ascii << "\n"
	        "P " << bc->partial << "\n"
	        "T " << bc->textinfo << "\n"
	        "E " << bc->encoding << "\n"
	        "X " << bc->width << "\n"
	        "M " << bc->margin << "\n"
	        "Y " << bc->height << "\n"
	        ;
	
	Barcode_Delete(bc);
	return 0;
}
